<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { CONTENT_TYPES } from '../../../common/content-types';
import {
  CardBasicStyle,
  GradientHero,
  NextStepAlt,
  Quote,
  SideNavigationVariant,
  TextBlockWithButtons,
} from '../../../components/common/index.vue';
import { getClient } from '~/plugins/contentful.js';
import { SolutionsResourceCards } from '~/components/solutions/index.vue';
import { techPartnerChildrenHelper } from '~/services/partners/technology-partners-children.service';
import { FooterEditLinkMixin } from '~/mixins';
import { getPageMetadata } from '~/common/meta';
import { convertToCaseSensitiveLocale } from '~/common/util';

export default Vue.extend({
  components: {
    NextStepAlt,
    GradientHero,
    SolutionsResourceCards,
    SideNavigationVariant,
    CardBasicStyle,
    TextBlockWithButtons,
    Quote,
  },
  mixins: [FooterEditLinkMixin],
  async asyncData({ params, i18n }: any) {
    try {
      const partnerSlug = `partners/technology-partners/${params.partner}`;
      const entries = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': partnerSlug,
        include: 10,
        locale: convertToCaseSensitiveLocale(i18n.locale),
      });

      const spaceId = entries.items[0].sys.space.sys.id;
      const entryId = entries.items[0].sys.id;

      const { pageContent } = entries.items[0].fields;
      const seoMetadata = entries.items[0].fields.seoMetadata[0].fields;

      const metadata = {
        title: seoMetadata.title,
        description: seoMetadata.description,
        og_title: seoMetadata.title,
        og_description: seoMetadata.description,
      };

      const partner = techPartnerChildrenHelper(pageContent);

      return { partner, metadata, spaceId, entryId, partnerSlug, pageContent };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).metadata,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <div :class="partnerSlug.includes('aws') ? 'partners-aws' : ''">
    <GradientHero
      :title="partner.hero.title"
      :subtitle="partner.hero.subtitle"
      :primary-button="partner.hero.primaryButton"
      :secondary-button="partner.hero.secondaryButton"
    />
    <SideNavigationVariant
      class="partners__sidenavigation"
      :links="partner.navLinks.anchors"
      :partners-variation="true"
      :nav-image="partner.navLinks.image"
      :partner-buttons="partner.navLinks.buttons"
      :footer-text-link="partner.navLinks.textLink"
      :footer="partner.navLinks.footer"
    >
      <SlpContainer id="overview" class="partners__headlines">
        <TextBlockWithButtons
          v-for="card in partner.headlines.cards"
          :key="card.title"
          :data="card"
        />
      </SlpContainer>
      <SlpContainer class="partners__benefits">
        <CardBasicStyle
          v-for="card in partner.benefits.cards"
          :key="card.title"
          :no-hover="true"
          :padding-size="24"
          :no-header="true"
          class="slp-mb-32"
        >
          <div class="partners__benefits-card-title">
            <SlpIcon
              v-if="card.icon.name"
              :alt="card.icon.alt"
              size="md"
              :variant="card.icon.variant"
              :name="card.icon.name"
            />
            <SlpTypography
              tag="h4"
              variant="heading5-bold"
              class="slp-mb-16 slp-ml-16"
              >{{ card.title }}</SlpTypography
            >
          </div>
          <SlpTypography
            tag="p"
            variant="body1"
            class="partners__benefits-card-body"
            :class="{ 'slp-mr-16': card.button.fields }"
            >{{ card.description }}</SlpTypography
          >
          <SlpButton
            v-if="card.button.fields"
            variant="primary"
            :href="card.button.fields.externalUrl"
            :data-ga-name="card.button.fields.dataGaName"
            :data-ga-location="card.button.fields.dataGaLocation"
          >
            {{ card.button.fields.text }}
            <SlpIcon
              v-if="card.button.fields.iconName"
              size="sm"
              class="slp-ml-8"
              :variant="card.button.fields.iconVariant"
              :name="card.button.fields.iconName"
            />
          </SlpButton>
        </CardBasicStyle>
      </SlpContainer>
      <SlpContainer id="testimonials">
        <Quote :data="partner.quote" />
      </SlpContainer>
      <SlpContainer id="get-started" variant="light-purple-100" :offset="2">
        <section class="partners__solutions">
          <TextBlockWithButtons :data="partner.solutions" class="slp-mb-32" />
          <div
            v-for="card in partner.solutions.cards"
            :key="card.title"
            class="partners__solutions-cards"
          >
            <SlpTypography tag="h5" variant="heading5-bold" class="slp-mb-16">{{
              card.title
            }}</SlpTypography>
            <SlpTypography tag="p" variant="body1" class="slp-mb-32">{{
              card.description
            }}</SlpTypography>
            <SlpButton
              v-if="card.button.text"
              :href="card.button.href"
              variant="tertiary"
            >
              {{ card.button.text }}
              <SlpIcon name="chevron-lg-right" variant="product" />
            </SlpButton>
          </div>
        </section>
      </SlpContainer>
    </SideNavigationVariant>
    <SlpContainer>
      <SolutionsResourceCards
        :data="partner.resourceCards"
        class="partners__resources"
      />
    </SlpContainer>
    <NextStepAlt class="partners__next-steps" />
  </div>
</template>

<style lang="scss" scoped>
div[role='main'] {
  overflow: clip;
}
.partners {
  &__headlines {
    margin-top: $spacing-32;
  }

  &__benefits {
    margin-top: $spacing-48;
    &-card {
      &-title {
        display: flex;
      }
    }
  }
  &__solutions {
    height: 100%;
    padding: $spacing-96 0 $spacing-24;
    position: relative;
    &::v-deep p strong {
      font-weight: 600;
    }
    &-cards {
      background-color: $color-surface-50;
      padding: $spacing-24;
      margin-bottom: $spacing-24;
    }
    &:after {
      content: '';
      position: absolute;
      width: 200vw;
      height: 100%;
      top: 0;
      left: -50vw;
      z-index: -1;
      background: $color-surface-800;
    }
  }
  &__sidenavigation {
    :deep {
      .side-navigation.slp-col-md-3 {
        @media (min-width: $breakpoint-sm) {
          position: relative;
          width: 100%;
          min-height: 1px;
          flex: 0 0 25%;
          max-width: 25%;
        }
        .side-navigation__wrapper {
          @media (min-width: $breakpoint-sm) {
            display: block !important;
          }
        }
        + .slp-col-md {
          @media (min-width: $breakpoint-sm) {
            max-width: 75%;
          }
        }
      }
      #side-nav-parent {
        @media (max-width: $breakpoint-md) {
          margin-top: 2.4rem;
        }
      }
    }
  }
  &__resources {
    :deep {
      .resources-container {
        overflow-y: hidden;
        .slp-col-lg-4 {
          max-width: 100%;
          min-width: 316px;
          @media (max-width: $breakpoint-lg) {
            max-width: 50%;
          }
          .resources-card-video-card {
            margin: 0 1.6rem 1.6rem 0;
          }
        }
      }
    }
  }
}
.partners-aws {
  .gradient-hero {
    :deep .slp-text-heading5 {
      max-width: 825px;
    }
  }
  .partners__benefits {
    .partners__benefits-card-body {
      font-size: 16px;
      line-height: 24px;
    }
    @media (min-width: $breakpoint-md) {
      display: grid;
      grid-template-columns: 1fr 1fr 1fr;
      grid-gap: 32px;
    }
    .partners__benefits-card-title {
      display: block;
      h4 {
        font-size: 18px;
        line-height: 28px;
        margin: 16px 0;
      }
    }
  }
  .partners__next-steps {
    :deep {
      .slp-col-lg-6:first-of-type {
        .slp-btn {
          margin: 0 0.8rem 0.8rem 0 !important;
          @media (min-width: $breakpoint-md) {
          }
        }
        .slp-btn-secondary {
          border-radius: 4px;
          border: 1px solid $color-secondary-300;
          transition: 0.25s;
          &:hover,
          &:focus {
            border: 1px solid $color-surface-200;
          }
          &:nth-of-type(1),
          &:nth-of-type(2) {
            background-color: #000;
            color: #fff;
            &:hover,
            &:focus {
              background-color: $color-secondary-200;
              color: #000;
              border: 1px solid #000;
            }
          }
        }
      }
    }
  }
}
</style>
